PPATH - Prime Path


The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it's not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.

Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on...

Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.

    1033
    1733     
    3733     
    3739     
    3779
    8779
    8179     
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

Input

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.

Example

Input:
3
1033 8179
1373 8017
1033 1033

Output:
6
7
0

hide comments
hitesh87: 2017-12-16 19:07:19

Nice problem finally AC!!!

arjun8115: 2017-11-10 12:56:02

"Impossible " is impossible...

sonorous: 2017-10-24 20:55:31

TLE in first go!!
AC in second go!!!

Jasbir Singh: 2017-10-20 07:51:44

Spent 6 hours..But AC in one attempt. Awesome questions for beginners like me. :)

Omar: 2017-10-11 21:42:03

AC in one go 0.02 c++

javafreak: 2017-09-28 15:41:38

AC in 0.00s :) Pre populate the prime array using sieve of eratosthenes, next use bfs by considering each number as a node, and prime numbers reachable from it as connected edges , don't form a graph beforehand , that is not necessary, just keep on connecting edges on the go...

jaykay12: 2017-09-26 10:23:59

AC in one Go. :) Nice Implementation of BFS :)

parthendo: 2017-09-18 20:45:07

AC in one go ;)

vishesh197: 2017-09-02 07:56:09

just think it as a graph with prime number as nodes of graph and two nodes will have a edge only if they have 1 digit different.Use bfs to find shortest path
AC in 4th go...

aronzx: 2017-08-24 11:51:58

Nice problem teaching 2 concepts at once. AC in one go !


Added by:overwise
Date:2007-10-02
Time limit:2s
Source limit:50000B
Memory limit:1536MB
Cluster: Cube (Intel G860)
Languages:All except: ERL JS-RHINO NODEJS PERL6 VB.NET
Resource:ACM ICPC NWERC 2006